// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

/*
 * NOTE: This class is auto generated by the swagger code generator program (3.0.27).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package de.itzbund.egesetz.bmi.lea.api;

import de.itzbund.egesetz.bmi.lea.domain.dtos.bestand.CreateBestandsrechtDTO;
import de.itzbund.egesetz.bmi.lea.domain.dtos.document.DocumentDTO;
import de.itzbund.egesetz.bmi.lea.domain.dtos.document.DocumentSummaryDTO;
import de.itzbund.egesetz.bmi.lea.domain.dtos.document.UpdateDocumentDTO;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PatchMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import javax.validation.Valid;
import java.util.UUID;

import static de.itzbund.egesetz.bmi.lea.api.ApiConstants.API_DIV_BESTANDSRECHT;
import static de.itzbund.egesetz.bmi.lea.api.ApiConstants.API_DIV_DOCUMENTS;

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen", date = "2021-11-03T11:39:02.977Z[GMT]")
@Validated
public interface DocumentsApi {

    /**
     * GET /documents/noAnnotations/{id} : Returns a single document (with annotations) if it exists and the user has the right to access it.
     *
     * @param id Uuid of the document (required)
     * @return OK (status code 200) or Access token is missing or invalid (status code 401) or User has invalid rights (status code 403) or Not Found
     * &lt;/br&gt; Document not found or **documentId** invalid. (status code 404)
     */
    @Operation(summary = "Returns a single document if it exists and the user has the right to access it.", description = "",
        tags = {API_DIV_DOCUMENTS},
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json", schema = @Schema(implementation = DocumentDTO.class))),
            @ApiResponse(responseCode = "401", description = "Access token is missing or invalid", content = @Content()),
            @ApiResponse(responseCode = "403", description = "User has invalid rights", content = @Content()),
            @ApiResponse(responseCode = "404", description = "Not Found </br> Document not found or **documentId** invalid.", content = @Content())
        }
    )
    @GetMapping(value = "/documents/noAnnotations/{id}",
        produces = {"application/json"})
    ResponseEntity<DocumentDTO> getWithoutAnnotations(
        @Parameter(name = "id",
            description = "Uuid of the document",
            required = true,
            schema = @Schema())
        @PathVariable("id") UUID documentId
    );

    /**
     * GET /documents/{id} : Returns a single document if it exists and the user has the right to access it.
     *
     * @param id Uuid of the document (required)
     * @return OK (status code 200) or Access token is missing or invalid (status code 401) or User has invalid rights (status code 403) or Not Found
     * &lt;/br&gt; Document not found or **documentId** invalid. (status code 404)
     */
    @Operation(summary = "Returns a single document if it exists and the user has the right to access it.", description = "",
        tags = {API_DIV_DOCUMENTS},
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json", schema = @Schema(implementation = DocumentDTO.class))),
            @ApiResponse(responseCode = "401", description = "Access token is missing or invalid", content = @Content()),
            @ApiResponse(responseCode = "403", description = "User has invalid rights", content = @Content()),
            @ApiResponse(responseCode = "404", description = "Not Found </br> Document not found or **documentId** invalid.", content = @Content())
        }
    )
    @GetMapping(value = "/documents/{id}",
        produces = {"application/json"})
    ResponseEntity<DocumentDTO> get(
        @Parameter(name = "id",
            description = "Uuid of the document",
            required = true,
            schema = @Schema())
        @PathVariable("id") UUID documentId
    );

    /**
     * PATCH /documents/{id} : Updates an existing document. All information given in the request object will be replaced.
     *
     * @param id                Uuid of the document (required)
     * @param updateDocumentDTO (required)
     * @return OK &lt;br&gt; The document was **successfully** updated.  (status code 200) or Bad Request &lt;/br&gt; Content is invalid. (status code 400) or
     * Access token is missing or invalid (status code 401) or User has invalid rights (status code 403) or Not Found &lt;/br&gt;  Document not found or
     * **documentId** invalid. (status code 404) or Internal Server Error &lt;/br&gt; Some error during server-side processing occurred. (status code 500)
     */
    @Operation(summary = "Updates an existing document.", description = "All information given in the request object will be replaced.",
        tags = {API_DIV_DOCUMENTS},
        responses = {
            @ApiResponse(responseCode = "200", description = "OK <br> The document was **successfully** updated. ", content = @Content(mediaType = "application/json", schema = @Schema(implementation = DocumentDTO.class))),
            @ApiResponse(responseCode = "400", description = "Bad Request </br> Content is invalid.", content = @Content()),
            @ApiResponse(responseCode = "401", description = "Access token is missing or invalid", content = @Content()),
            @ApiResponse(responseCode = "403", description = "User has invalid rights", content = @Content()),
            @ApiResponse(responseCode = "404", description = "Not Found </br>  Document not found or **documentId** invalid.", content = @Content()),
            @ApiResponse(responseCode = "405", description = "Not Permission </br>  Document is read only.", content = @Content()),
            @ApiResponse(responseCode = "500", description = "Internal Server Error </br> Some error during server-side processing occurred.", content = @Content())
        }
    )
    @PatchMapping(value = "/documents/{id}",
        produces = {"application/json"},
        consumes = {"application/json"})
    ResponseEntity<DocumentDTO> update(
        @Parameter(name = "id", description = "Uuid of the document", required = true, schema = @Schema()) @PathVariable("id") UUID documentId,
        @Parameter(name = "UpdateDocumentDTO", description = "", required = true, schema = @Schema()) @Valid @RequestBody UpdateDocumentDTO updateDocumentDTO
    );

    /**
     * POST /documents/{id}/export : Exports a single document. Receives the Base64-encoded content of the JSON document in the content field of the
     * UpdateDocumentDTO and &lt;/br&gt; &lt;ul&gt; &lt;li&gt;(i) decodes it into JSON,&lt;/li&gt; &lt;li&gt;(ii) transformes it into XML, and&lt;/li&gt;
     * &lt;li&gt;(iii) validates the XML string against the respective schemas,&lt;/li&gt; &lt;/ul&gt; then returns the XML content as string, or if one of
     * these steps fails, returns HTTP 400 Bad Request.
     *
     * @param updateDocumentDTO (required)
     * @return OK (status code 200) or Access token is missing or invalid (status code 401) or User has invalid rights (status code 403) or Document could not
     * be exported due to either JSON parsing error or failed XML validation (status code 409) or Internal Server Error &lt;/br&gt; Some error during
     * server-side processing occurred. (status code 500)
     */
    @Operation(
        operationId = "exportDocument",
        summary = "Exports a single document.",
        description =
            "Receives the Base64-encoded content of the JSON document in the content field of the "
                + "UpdateDocumentDTO and </br>\n"
                + "     <ul> <li>(i) decodes it into JSON,</li>\n"
                + "          <li>(ii) transformes it into XML, and</li>\n"
                + "          <li>(iii) validates the XML string against the respective schemas,</li>\n"
                + "     </ul>\n"
                + "     then returns the XML content as string, or if one of these steps fails, returns "
                + "HTTP 400 Bad Request.",
        tags = {API_DIV_DOCUMENTS},
        responses = {
            @ApiResponse(responseCode = "200", description = "OK",
                content = @Content(mediaType = "application/xml",
                    schema = @Schema(implementation = String.class))),
            @ApiResponse(responseCode = "409",
                description = "Document could not be exported due to either JSON parsing error or failed "
                    + "XML validation",
                content = @Content()),
            @ApiResponse(responseCode = "500",
                description = "Internal Server Error </br> Some error during server-side processing "
                    + "occurred.",
                content = @Content())
        }
    )
    @PostMapping(
        value = "/documents/{id}/export"
    )
    ResponseEntity<String> exportDocument(
        @Parameter(name = "UpdateDocumentDTO",
            description = "The Base64-encoded JSON content of the document straight from the editor client.",
            required = true, schema = @Schema())
        @Valid @RequestBody UpdateDocumentDTO updateDocumentDTO
    );


    @Operation(
        operationId = "saveAsBestandsrecht",
        summary = "Speichert den Regelungstext in Stammform als Bestandsrecht",
        tags = {API_DIV_BESTANDSRECHT},
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json", schema = @Schema(implementation = DocumentDTO.class))),
            @ApiResponse(responseCode = "400", description = "Bad Request </br> Content is invalid.", content = @Content()),
            @ApiResponse(responseCode = "401", description = "Access token is missing or invalid", content = @Content()),
            @ApiResponse(responseCode = "403", description = "User has invalid rights", content = @Content()),
            @ApiResponse(responseCode = "404", description = "Not Found </br>  Document not found or **documentId** invalid.", content = @Content()),
            @ApiResponse(responseCode = "500", description = "Internal Server Error", content = @Content())
        }
    )
    @PostMapping(
        value = "/documents/{id}/bestandsrecht",
        produces = {"application/json"},
        consumes = {"application/json"}
    )
    ResponseEntity<DocumentSummaryDTO> saveAsBestandsrecht(
        @Parameter(name = "id", description = "Uuid of the document", required = true, schema = @Schema())
        @PathVariable("id")
        UUID documentId,
        @Parameter(name = "CreateBestandsrechtDTO", description = "the payload", required = true, schema = @Schema())
        @Valid @RequestBody
        CreateBestandsrechtDTO createBestandsrechtDTO
    );

}
